



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>git的一些常见命令</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">git的一些常见命令</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 22:48:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>一、新建代码库</h2>
<blockquote><pre class="prettyprint linenums"><code><br />
# 在当前目录新建一个Git代码库<br />
$ git init

# 新建一个目录，将其初始化为Git代码库<br />
$ git init [project-name]

# 下载一个项目和它的整个代码历史<br />
$ git clone [url]<br />
</code></pre></blockquote>
<h2>二、配置</h2>
<p>Git的设置文件为<code>.gitconfig</code>，它可以在用户主目录下（全局配置），也可以在项目目录下（项目配置）。</p>
<blockquote><pre class="prettyprint linenums"><code><br />
# 显示当前的Git配置<br />
$ git config --list

# 编辑Git配置文件<br />
$ git config -e [--global]

# 设置提交代码时的用户信息<br />
$ git config [--global] user.name "[name]"<br />
$ git config [--global] user.email "[email address]"<br />
</code></pre></blockquote>
<h2>三、增加/删除文件</h2>
<blockquote><pre class="prettyprint linenums"><code><br />
# 添加指定文件到暂存区<br />
$ git add [file1] [file2] ...

# 添加指定目录到暂存区，包括子目录<br />
$ git add [dir]

# 添加当前目录的所有文件到暂存区<br />
$ git add .

# 添加每个变化前，都会要求确认<br />
# 对于同一个文件的多处变化，可以实现分次提交<br />
$ git add -p

# 删除工作区文件，并且将这次删除放入暂存区<br />
$ git rm [file1] [file2] ...

# 停止追踪指定文件，但该文件会保留在工作区<br />
$ git rm --cached [file]

# 改名文件，并且将这个改名放入暂存区<br />
$ git mv [file-original] [file-renamed]<br />
</code></pre></blockquote>
<h2>四、代码提交</h2>
<blockquote><pre class="prettyprint linenums"><code><br />
# 提交暂存区到仓库区<br />
$ git commit -m [message]

# 提交暂存区的指定文件到仓库区<br />
$ git commit [file1] [file2] ... -m [message]

# 提交工作区自上次commit之后的变化，直接到仓库区<br />
$ git commit -a

# 提交时显示所有diff信息<br />
$ git commit -v

# 使用一次新的commit，替代上一次提交<br />
# 如果代码没有任何新变化，则用来改写上一次commit的提交信息<br />
$ git commit --amend -m [message]

# 重做上一次commit，并包括指定文件的新变化<br />
$ git commit --amend [file1] [file2] ...<br />
</code></pre></blockquote>
<h2>五、分支</h2>
<blockquote><pre class="prettyprint linenums"><code><br />
# 列出所有本地分支<br />
$ git branch

# 列出所有远程分支<br />
$ git branch -r

# 列出所有本地分支和远程分支<br />
$ git branch -a

# 新建一个分支，但依然停留在当前分支<br />
$ git branch [branch-name]

# 新建一个分支，并切换到该分支<br />
$ git checkout -b [branch]

# 新建一个分支，指向指定commit<br />
$ git branch [branch] [commit]

# 新建一个分支，与指定的远程分支建立追踪关系<br />
$ git branch --track [branch] [remote-branch]

# 切换到指定分支，并更新工作区<br />
$ git checkout [branch-name]

# 切换到上一个分支<br />
$ git checkout -

# 建立追踪关系，在现有分支与指定的远程分支之间<br />
$ git branch --set-upstream [branch] [remote-branch]

# 合并指定分支到当前分支<br />
$ git merge [branch]

# 选择一个commit，合并进当前分支<br />
$ git cherry-pick [commit]

# 删除分支<br />
$ git branch -d [branch-name]

# 删除远程分支<br />
$ git push origin --delete [branch-name]<br />
$ git branch -dr [remote/branch]<br />
</code></pre></blockquote>
<h2>六、标签</h2>
<blockquote><pre class="prettyprint linenums"><code><br />
# 列出所有tag<br />
$ git tag

# 新建一个tag在当前commit<br />
$ git tag [tag]

# 新建一个tag在指定commit<br />
$ git tag [tag] [commit]

# 删除本地tag<br />
$ git tag -d [tag]

# 删除远程tag<br />
$ git push origin :refs/tags/[tagName]

# 查看tag信息<br />
$ git show [tag]

# 提交指定tag<br />
$ git push [remote] [tag]

# 提交所有tag<br />
$ git push [remote] --tags

# 新建一个分支，指向某个tag<br />
$ git checkout -b [branch] [tag]<br />
</code></pre></blockquote>
<h2>七、查看信息</h2>
<blockquote><pre class="prettyprint linenums"><code><br />
# 显示有变更的文件<br />
$ git status

# 显示当前分支的版本历史<br />
$ git log

# 显示commit历史，以及每次commit发生变更的文件<br />
$ git log --stat

# 搜索提交历史，根据关键词<br />
$ git log -S [keyword]

# 显示某个commit之后的所有变动，每个commit占据一行<br />
$ git log [tag] HEAD --pretty=format:%s

# 显示某个commit之后的所有变动，其"提交说明"必须符合搜索条件<br />
$ git log [tag] HEAD --grep feature

# 显示某个文件的版本历史，包括文件改名<br />
$ git log --follow [file]<br />
$ git whatchanged [file]

# 显示指定文件相关的每一次diff<br />
$ git log -p [file]

# 显示过去5次提交<br />
$ git log -5 --pretty --oneline

# 显示所有提交过的用户，按提交次数排序<br />
$ git shortlog -sn

# 显示指定文件是什么人在什么时间修改过<br />
$ git blame [file]

# 显示暂存区和工作区的差异<br />
$ git diff

# 显示暂存区和上一个commit的差异<br />
$ git diff --cached [file]

# 显示工作区与当前分支最新commit之间的差异<br />
$ git diff HEAD

# 显示两次提交之间的差异<br />
$ git diff [first-branch]...[second-branch]

# 显示今天你写了多少行代码<br />
$ git diff --shortstat "@{0 day ago}"

# 显示某次提交的元数据和内容变化<br />
$ git show [commit]

# 显示某次提交发生变化的文件<br />
$ git show --name-only [commit]

# 显示某次提交时，某个文件的内容<br />
$ git show [commit]:[filename]

# 显示当前分支的最近几次提交<br />
$ git reflog<br />
</code></pre></blockquote>
<h2>八、远程同步</h2>
<blockquote><pre class="prettyprint linenums"><code><br />
# 下载远程仓库的所有变动<br />
$ git fetch [remote]

# 显示所有远程仓库<br />
$ git remote -v

# 显示某个远程仓库的信息<br />
$ git remote show [remote]

# 增加一个新的远程仓库，并命名<br />
$ git remote add [shortname] [url]

# 取回远程仓库的变化，并与本地分支合并<br />
$ git pull [remote] [branch]

# 上传本地指定分支到远程仓库<br />
$ git push [remote] [branch]

# 强行推送当前分支到远程仓库，即使有冲突<br />
$ git push [remote] --force

# 推送所有分支到远程仓库<br />
$ git push [remote] --all<br />
</code></pre></blockquote>
<h2>九、撤销</h2>
<blockquote><pre class="prettyprint linenums"><code><br />
# 恢复暂存区的指定文件到工作区<br />
$ git checkout [file]

# 恢复某个commit的指定文件到暂存区和工作区<br />
$ git checkout [commit] [file]

# 恢复暂存区的所有文件到工作区<br />
$ git checkout .

# 重置暂存区的指定文件，与上一次commit保持一致，但工作区不变<br />
$ git reset [file]

# 重置暂存区与工作区，与上一次commit保持一致<br />
$ git reset --hard

# 重置当前分支的指针为指定commit，同时重置暂存区，但工作区不变<br />
$ git reset [commit]

# 重置当前分支的HEAD为指定commit，同时重置暂存区和工作区，与指定commit一致<br />
$ git reset --hard [commit]

# 重置当前HEAD为指定commit，但保持暂存区和工作区不变<br />
$ git reset --keep [commit]

# 新建一个commit，用来撤销指定commit<br />
# 后者的所有变化都将被前者抵消，并且应用到当前分支<br />
$ git revert [commit]

# 暂时将未提交的变化移除，稍后再移入<br />
$ git stash<br />
$ git stash pop<br />
</code></pre></blockquote>
<h2>十、其他</h2>
<blockquote><pre class="prettyprint linenums"><code><br />
# 生成一个可供发布的压缩包<br />
$ git archive</code></pre></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qny3g8r.html">瞬间记住Javascript中apply与call的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g05nzq.html">telnet&colon; connect to address 127&period;0&period;0&period;1&colon; Connection refused</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvmye1q.html">Git的配置及常用命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9prrj4q.html">读书笔记&lowbar;Effective&lowbar;C&plus;&plus;&lowbar;条款四十四：将与参数无关的代码抽离template</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j55n08.html">开启mysql慢查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vjxw38.html">Spring MVC体系结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1rnj59.html">转：Bitbucket使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnxjppq.html">java&lowbar;spring&lowbar;bean的作用域&lowbar;实例是否为单实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdxpll8.html">问题-&amp;quot&semi;Record not found or changed by another user&amp;quot&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd75j79.html">springmvc03-异常处理-静态文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj06pxq.html">单片机开发&mdash;&mdash;01工欲善其事必先利其器（Keil软件安装破解）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpyz479.html">MySQL外键设置中的的 Cascade、NO ACTION、Restrict、SET NULL</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjj0kr9.html">无法获得锁 &sol;var&sol;lib&sol;dpkg&sol;lock - open</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2zxloq.html">JAVA常用工具类汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll05x0q.html">Zabbix使用grafana展示图形</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyn57x9.html">methods  方法选项</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj77449.html">&lbrack;转载&rsqb;Python正则表达式匹配反斜杠&amp;&num;39&semi;&bsol;&amp;&num;39&semi;问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppdxzk9.html">Vmware ESXi添加共享磁盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnn223q.html">jQuery&period;fly插件实现添加购物车抛物线效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkke6v8.html">SpringMVC深度探险（一） &mdash;&mdash; SpringMVC前传</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8ojo46lq.html">Codeforces Round &num;416&lpar;Div&period; 2&rpar;-811A&period;。。。 811B&period;。。。 811C&period;dp。。。不会</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gek47e8.html">Kubernetes v1&period;6开始支持RBAC</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzgp348.html">浏览器与CDN缓存行为</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jv2wx8.html">TF-IDF&lowbar;MapReduceJava代码实现思路</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp4vl79.html">Laravel5&period;5 的 Homestead 开发环境部署</a>
			</li>
						<li><a href="https://www.batexi.com/a/950ydn08.html">关于Vue的路由、脚手架笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkxzrd8.html">requireJs 踩的坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1xonjq.html">&period;net 和 core2&period;0 数据库连接字符串</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjxzyy8.html">解决前端页面a标签嵌套a标签bug</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k222z9.html">JavaScript ES6 let、const</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
